(* Dialog for HTTP proxy connection parameters

    Dr. J. Rathlev, D-24222 Schwentinental (info(a)rathlev-home.de)

   The contents of this file may be used under the terms of the
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.

   Vers. 1 - Nov. 2009
   *)

unit HttpProxyDlg;

interface

uses Winapi.Windows, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Forms,
  Vcl.Controls, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, NumberEd, WebUpdateDlg;

type
  THttpProxyDialog = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    btnShow: TSpeedButton;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    edProxy: TEdit;
    edUser: TEdit;
    edProxyPwd: TEdit;
    edtPort: TRangeEdit;
    cbUseProxy: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnShowClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function Execute (var AProxyPar : THttpProxyParams; ShowPwd : boolean) : boolean;
  end;

function EditHttpProxy (var AProxyPar : THttpProxyParams; ShowPwd : boolean) : boolean;

var
  HttpProxyDialog: THttpProxyDialog;

implementation

{$R *.dfm}

uses GnuGetText;

{------------------------------------------------------------------- }
procedure THttpProxyDialog.FormCreate(Sender: TObject);
begin
  TranslateComponent (self,'dialogs');
  end;

procedure THttpProxyDialog.btnShowClick(Sender: TObject);
var
  c : char;
begin
  if btnShow.Down then c:=#0 else c:='*';
  edProxyPwd.PasswordChar:=c;
  end;

{------------------------------------------------------------------- }
function THttpProxyDialog.Execute (var AProxyPar : THttpProxyParams; ShowPwd : boolean) : boolean;
begin
  btnShow.Visible:=ShowPwd;
  with AProxyPar do begin
    edProxy.Text:=Server;
    edtPort.Value:=Port;
    edUser.Text:=Username;
    edProxyPwd.Text:=Password;
    cbUseProxy.Checked:=UseProxy;
    ActiveControl:=edProxy;
    if ShowModal=mrOK then begin
      Server:=edProxy.Text;
      Port:=edtPort.Value;
      Username:=edUser.Text;
      Password:=edProxyPwd.Text;
      UseProxy:=cbUseProxy.Checked;
      Result:=true;
      end
    else Result:=false;
    end;
  end;

{------------------------------------------------------------------- }
function EditHttpProxy (var AProxyPar : THttpProxyParams; ShowPwd : boolean) : boolean;
begin
  if not assigned(HttpProxyDialog) then HttpProxyDialog:=THttpProxyDialog.Create(Application);
  Result:=HttpProxyDialog.Execute(AProxyPar,ShowPwd);
  FreeAndNil(HttpProxyDialog);
  end;

end.
