(* Delphi Dialog
   Formateinstellungen fr CSV-Daten-Export
   ========================================
   
    Dr. J. Rathlev, D-24222 Schwentinental (info(a)rathlev-home.de)

   The contents of this file may be used under the terms of the
   Mozilla Public License ("MPL") or
   GNU Lesser General Public License Version 2 or later (the "LGPL")

   Software distributed under this License is distributed on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
   the specific language governing rights and limitations under the License.
   
   Vers. 1 - Mai 2005 
   *)
   
unit ExportDlg;

interface

uses Winapi.Windows, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Forms,
  Vcl.Controls, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, NumberEd;

type
  TExportDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    DelimGroup: TRadioGroup;
    DelChar: TEdit;
    SpaltGroup: TRadioGroup;
    Panel1: TPanel;
    EncloseCB: TCheckBox;
    reColWidth: TRangeEdit;
    udColWidth: TNumUpDown;
    procedure DelimGroupClick(Sender: TObject);
    procedure SpaltGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    NDel : char;
  public
    { Public declarations }
    (* Dialog anzeigen *)
    function Execute (Titel : string;
                      var Delim     : char;
                      var ColWidth  : integer;
                      var Fill,Enclose : boolean) : boolean;
  end;

var
  ExportDialog: TExportDialog;

implementation

{$R *.DFM}

uses StringUtils;

{ ------------------------------------------------------------------- }
procedure TExportDialog.FormCreate(Sender: TObject);
begin
  // ***
  end;

procedure TExportDialog.DelimGroupClick(Sender: TObject);
begin
  with DelimGroup do if ItemIndex=2 then begin
    DelChar.Show;
    end
  else begin
    case ItemIndex of
      0 : NDel:=Space;
      1 : NDel:=';';
      3 : NDel:=',';
      4 : NDel:=Tab;
        end;
    DelChar.Hide;
    end;
  end;

procedure TExportDialog.SpaltGroupClick(Sender: TObject);
begin
  reColWidth.Visible:=SpaltGroup.ItemIndex=0;
  end;

{ ------------------------------------------------------------------- }
(* Dialog anzeigen *)
function TExportDialog.Execute (Titel : string;
                                var Delim     : char;
                                var ColWidth  : integer;
                                var Fill,Enclose : boolean) : boolean;
var
  ok : boolean;
begin
  if length(Titel)>0 then Caption:=Titel;
  NDel:=Delim; DelChar.Text:='';
  with DelimGroup do begin
    DelChar.Hide;
    case NDel of
    Space     : ItemIndex:=0;
    ';' : ItemIndex:=1;
    ','     : ItemIndex:=3;
    Tab       : ItemIndex:=4;
      else with DelChar do begin
        ItemIndex:=2;
        Text:=NDel; Show;
        end;
      end;
    end;
  with SpaltGroup do if Fill then ItemIndex:=0 else ItemIndex:=1;
  EncloseCB.Checked:=Enclose;
  with reColWidth do begin
    Value:=ColWidth; Visible:=Fill;
    end;
  ok:=ShowModal=mrOK;
  if ok then begin
    if DelimGroup.ItemIndex=2 then NDel:=DelChar.Text[1];
    Delim:=NDel;
    Fill:=SpaltGroup.ItemIndex=0;
    if Fill then ColWidth:=reColWidth.Value;
    Enclose:=EncloseCB.Checked;
    Result:=true;
    end
  else Result:=false;
  end;

end.
