(* Delphi-Unit
   Eingabefenster fr mehrzeiligen Text
   J. Rathlev, Mrz. 2008 *)

unit MemoDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TMemoDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Descriptor: TLabel;
    Memo: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function Execute(Pos        : TPoint;
                     BottomPos  : boolean;
                     Titel,Desc : string;
                     var AText  : string) : boolean;
  end;

function ShowMemo (Pos : TPoint; BottomPos  : boolean;
                   Titel,Desc : string; var AText  : string) : boolean;

var
  MemoDialog: TMemoDialog;

implementation

{$R *.dfm}

uses JrUtils;

{------------------------------------------------------------------- }
procedure TMemoDialog.FormCreate(Sender: TObject);
begin
  // ***
  end;

{------------------------------------------------------------------- }
function TMemoDialog.Execute(Pos        : TPoint;
                             BottomPos  : boolean;
                             Titel,Desc : string;
                             var AText  : string) : boolean;
begin
  with Pos do begin
    if (Y < 0) or (X < 0) then Position:=poScreenCenter
    else begin
      Position:=poDesigned;
      if X<0 then X:=Left;
      if Y<0 then Y:=Top
      else if BottomPos then y:=y-Height;
      CheckScreenBounds(Screen,x,y,Width,Height);
      Left:=x; Top:=y;
      end;
    end;
  Caption:=Titel;
  Descriptor.Caption:=Desc;
  Memo.Lines.CommaText:=AText;
  if ShowModal=mrOK then begin
    AText:=Memo.Lines.CommaText;
    Result:=true;
    end
  else Result:=false;
  end;

{------------------------------------------------------------------- }
function ShowMemo (Pos : TPoint; BottomPos  : boolean;
                   Titel,Desc : string; var AText  : string) : boolean;

begin
  if not assigned(MemoDialog) then MemoDialog:=TMemoDialog.Create(Application);
  Result:=MemoDialog.Execute(Pos,BottomPos,Titel,Desc,AText);
  FreeAndNil(MemoDialog);
  end;

end.
